/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef PWMANAGER_GENERICDEBUG_H_
#define PWMANAGER_GENERICDEBUG_H_

#include "globalstuff.h"


class PwMApplication;
class PwMInit;


#ifdef PWM_DEBUG

class GenericDebug
{
protected:
	GenericDebug();
	~GenericDebug();

public:
	/** This function is called very early in main(). */
	static void earlyDebug();
	/** This function is called just before the PwMApplication
	  * object is created.
	  */
	static void prePwMApplicationDebug();
	/** This function is called just after the PwMApplication
	  * object has been created.
	  */
	static void postPwMApplicationDebug(PwMApplication *app);
	/** This function is called after PwMInit::initializeApp(). */
	static void postInitDebug(PwMInit *init);

protected:
	void do_earlyDebug();
	void do_prePwMApplicationDebug();
	void do_postPwMApplicationDebug(PwMApplication *app);
	void do_postInitDebug(PwMInit *init);
};


#else // PWM_DEBUG


class GenericDebug
{
protected:
	GenericDebug() { }

public:
	static inline void earlyDebug() { }
	static inline void prePwMApplicationDebug() { }
	static inline void postPwMApplicationDebug(PwMApplication *) { }
	static inline void postInitDebug(PwMInit *) { }
};

#endif // PWM_DEBUG
#endif // PWMANAGER_GENERICDEBUG_H_
