/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "genpasswd_extern.h"
#include "pwmexception.h"

#include <qstringlist.h>
#include <qregexp.h>


GenPasswd_extern::GenPasswd_extern()
{
	connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)),
		this, SLOT(receivedStdout(KProcess *, char *, int)));
}

GenPasswd_extern::~GenPasswd_extern()
{
}

QString GenPasswd_extern::gen()
{
	recStdout = QString::null;
	proc.clearArguments();
	cmd.stripWhiteSpace();
	proc << QStringList::split(QRegExp("\\s"), cmd);
	proc.start(KProcess::Block, KProcess::Stdout);
	/* a random writespace is added at the end. why?
	 * remove it here.
	 */
	recStdout.remove(recStdout.length() - 1, 1);
	return recStdout;
}

void GenPasswd_extern::receivedStdout(KProcess *_proc, char *buffer, int buflen)
{
	PWM_ASSERT(_proc == &proc);
	recStdout += QString::fromAscii(buffer, buflen);
}

#include "genpasswd_extern.moc"
