/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004, 2005  by Michael Buesch                           *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#define NEED_HUMAN_READABLE_HEX
#include "globalstuff.h"
#include "pwminit.h"
#include "pwgenwndimpl.h"

#include <qclipboard.h>
#include <qapplication.h>

#include <kinputdialog.h>
#include <klocale.h>

#include <stdio.h>
#include <string.h>


QString humanReadableHex(const QByteArray &d)
{
	unsigned int i, size = d.size();
	QString ret("0x");
	char tmp[3], cur;

	for (i = 0; i < size; ++i) {
		cur = d[i];
		if (cur == 0)
			ret += "00";
		else {
			sprintf(tmp, "%X", cur & 0xFF);
			if (strlen(tmp) == 1)
				ret += '0';
			ret += tmp;
		}
	}
	return ret;
}

PwMInit * PwMGlobal::_init (0);

void PwMGlobal::copyToClipboard(const QString &text)
{
	QClipboard *cb = QApplication::clipboard();
	if (cb->supportsSelection())
		cb->setText(text, QClipboard::Selection);
	cb->setText(text, QClipboard::Clipboard);
}

void PwMGlobal::genPassword(QWidget *parent)
{
	if (!parent)
		parent = init()->curWidget();
	PwGenWndImpl wnd(parent);
	if (wnd.exec() == 0)
		return;
	bool ok = false;
	QString pw(wnd.getPassword());
	pw = KInputDialog::getText(i18n("Generated Password"),
				   i18n("This is your new Password.\n"
					"Click on OK to copy it to the clipboard."),
				   pw, &ok, parent);
	if (ok)
		copyToClipboard(pw);
}
