/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "libpwmanager/datahash.h"
#include "libpwmanager/libgcryptif.h"
#include "libpwmanager/sha1.h"
#include "rawfile/rawfile.h"


DataHash::DataHash()
{
}

DataHash::~DataHash()
{
}

bool DataHash::hash(const QByteArray &data,
		    QByteArray *hash,
		    unsigned char algo)
{
	switch (algo) {
	case PWM_HASH_SHA1: {
		Sha1 h;
		h.sha1_write(reinterpret_cast<const byte *>(data.data()),
			     data.size());
		h.sha1_read(hash);
		break;
	} case PWM_HASH_SHA256:
		/*... fall through */
	case PWM_HASH_SHA384:
	case PWM_HASH_SHA512:
	case PWM_HASH_MD5:
	case PWM_HASH_RMD160:
	case PWM_HASH_TIGER: {
#if 0
		if (!LibGCryptIf::available())
			return false;
		LibGCryptIf gc;
		unsigned int hashLen = gc.hashLength(algo);
		hash->resize(hashLen);
		//TODO: check error code here.
		gc.hash(
#endif
TODO();//TODO
return false;
		break;
	} default:
		return false;
	}
	return true;
}
