/***************************************************************************
 *                                                                         *
 *   copyright (C) 2003, 2004, 2005  by Michael Buesch                     *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef LIBPWMANAGER_FILECOMPRESS_H_
#define LIBPWMANAGER_FILECOMPRESS_H_

#include <qcstring.h>


class FileCompress
{
public:
	FileCompress()
		{ }

	/** compress the data */
	bool compress(QByteArray *data,
		      unsigned char algo);
	/** decompress the data */
	bool decompress(QByteArray *data,
			unsigned char algo);

protected:
	/** compress with GZIP */
	bool compressGzip(QByteArray *data);
	/** compress with BZIP2 */
	bool compressBzip2(QByteArray *data);
	/** decompress with GZIP */
	bool decompressGzip(QByteArray *data);
	/** decompress with BZIP2 */
	bool decompressBzip2(QByteArray *data);
};

#endif // LIBPWMANAGER_FILECOMPRESS_H_
