/***************************************************************************
 *                                                                         *
 *   copyright (C) 2005 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef PWMANAGER_UNIQUEID_H_
#define PWMANAGER_UNIQUEID_H_

#include <qcstring.h>

#include <set>

//TODO: remove
#include "pwmexception.h"


namespace PwManager
{

class UniqueIdContext
{
	friend class UniqueId;

protected:
	class id_t
	{
	public:
		id_t()
			{
				id = new QByteArray;
			}
		id_t(QByteArray *d)
			 : id (d)
			{ }
		id_t(const id_t &d)
			 : id (d.id)
			{ }
		~id_t()
			{ }

		bool operator< (const id_t &d) const
			{
cout << "id_t operator<" << endl;//TODO
				return (qstrcmp(*id, *d.id) < 0);
			}
		
/*
		bool operator== (const id_t &d)
			{//TODO
cout << "id_t operator==" << endl;
				return (*id == *d.id);
			}
*/
	public:
		/** Pointer to the QByteArray containing
		  * the ID data.
		  */
		QByteArray *id;
	};

public:
	/** Constructor.
	  * @param _length ID length in bytes.
	  */
	UniqueIdContext(unsigned int _length);
	/** Destructor. */
	~UniqueIdContext();

	/** Clear the ID-trash-container. */
	void clearTrash();

protected:
	/** Get a new context-unique ID. */
	QByteArray * get();
	/** Write an existing ID string into the
	  * context idSet.
	  */
	bool assign(QByteArray *d);
	/** Put an existing context-unique id. */
	void put(QByteArray *d);

protected:
	/** ID length in bytes. */
	unsigned int length;
	/** Set of all IDs. */
	std::set<id_t> idSet;
	/** Set of all trashed IDs. */
	std::set<id_t> idTrash;
};

} // namespace PwManager

#endif // PWMANAGER_UNIQUEID_H_
