/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "metawndimpl.h"
#include "libpwmanager/libpwmanager.h"

#include <qlabel.h>
#include <qdatetime.h>
#include <qdatetimeedit.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qradiobutton.h>


using namespace PwManager;


MetaWndImpl::MetaWndImpl(QWidget *parent,
			 const char *name,
			 bool modal,
			 WFlags fl)
 : MetaWnd(parent, name, modal, fl)
{
}

MetaWndImpl::~MetaWndImpl()
{
}

int MetaWndImpl::editMeta(DataItem *item)
{//TODO
}

#if 0
void MetaWndImpl::setContent(const QString &entryName,
			     const PwMMetaData &dta)
{
	titleLabel->setText(i18n("Meta information for entry:\n")
			    + entryName);
	if (dta.create.isNull()) {
		createLabel->setText(QDateTime::currentDateTime().toString(Qt::LocalDate));
	} else {
		createLabel->setText(dta.create.toString(Qt::LocalDate));
	}
	if (dta.update.isNull()) {
		updateLabel->setText(QDateTime::currentDateTime().toString(Qt::LocalDate));
	} else {
		updateLabel->setText(dta.update.toString(Qt::LocalDate));
	}
	if (dta.valid.isNull()) {
		validCheckBox->setChecked(false);
	} else {
		validCheckBox->setChecked(true);
		validDate->setDateTime(dta.valid);
	}
	if (dta.expire.isNull()) {
		expireCheckBox->setChecked(false);
	} else {
		expireCheckBox->setChecked(true);
		expireDate->setDateTime(dta.expire);
	}
	if (dta.updateInt != 0) {
		if ((dta.updateInt % 60) == 0) {
			if (((dta.updateInt / 60) % 24) == 0) {
				// we have days
				updateIntSpin->setValue(dta.updateInt / 60 / 24);
				updateDaysRadio->setChecked(true);
			} else {
				// we have hours
				updateIntSpin->setValue(dta.updateInt / 60);
				updateHoursRadio->setChecked(true);
			}
		} else {
			// we have minutes
			updateIntSpin->setValue(dta.updateInt);
			updateMinutesRadio->setChecked(true);
		}
	} else {
		updateIntSpin->setValue(0);
	}
}

void MetaWndImpl::getContent(PwMMetaData *dta)
{
	if (validCheckBox->isChecked()) {
		dta->valid = validDate->dateTime();
	} else {
		dta->valid = QDateTime();
	}
	if (expireCheckBox->isChecked()) {
		dta->expire = expireDate->dateTime();
	} else {
		dta->expire = QDateTime();
	}
	if (updateIntSpin->value() == 0) {
		dta->updateInt = 0;
	} else {
		if (updateDaysRadio->isChecked()) {
			dta->updateInt = updateIntSpin->value() * 60 * 24;
		} else if (updateHoursRadio->isChecked()) {
			dta->updateInt = updateIntSpin->value() * 60;
		} else if (updateMinutesRadio->isChecked()) {
			dta->updateInt = updateIntSpin->value();
		} else {
			BUG();
		}
	}
}
#endif

void MetaWndImpl::okButton_slot()
{
	done(1);
}

void MetaWndImpl::cancelButton_slot()
{
	done(0);
}

void MetaWndImpl::validTodayButton_slot()
{
	validDate->setDateTime(QDateTime::currentDateTime());
}

void MetaWndImpl::expireTodayButton_slot()
{
	expireDate->setDateTime(QDateTime::currentDateTime());
}

#include "metawndimpl.moc"
