/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004, 2005  by Michael Buesch                           *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef METAWNDIMPL_H_
#define METAWNDIMPL_H_

#include "metawnd.h"

namespace PwManager
{
	class DataItem;
}

class MetaWndImpl : public MetaWnd
{
	Q_OBJECT
public:
	MetaWndImpl(QWidget *parent = 0,
		    const char *name = 0,
		    bool modal = FALSE,
		    WFlags fl = 0);
	~MetaWndImpl();

	/** Open a window to edit the meta information. */
	int editMeta(PwManager::DataItem *item);

protected slots:
	/** ok button pressed */
	void okButton_slot();
	/** cancel button pressed */
	void cancelButton_slot();
	/** valid/today button pressed */
	void validTodayButton_slot();
	/** expire/today button pressed */
	void expireTodayButton_slot();
};

#endif // METAWNDIMPL_H_
